#include <allegro.h>
#include <socket.h>
#include <stdio.h>
#include <time.h>
#include <dir.h>
#include <string.h>
#include <process.h>
#include <signal.h>
#include <stdlib.h>
#include <math.h>
#include <jpgalleg.h>
#include <algif.h>
#include <allegttf.h>
#include <sys/stat.h>
#include <setjmp.h>
#include "..\dcm\dyncom.h"
#include "fontdata.c"
#include "font.c"
#define VERSION 1.0
#define MAXAPPS         20
DCM  *app_dcm;
struct sockaddr_in addr;  //for networking
struct hostent *he;
fd_set readhandles;
struct timeval timeout;

//mouse handler vars
BITMAP *mousecursor;
BITMAP *mousescreen;
int oldmousex;
int oldmousey;
int mousehidden;
char * clipboard;
jmp_buf env;

//Ikon applications
typedef struct apps APPS;               //applications and tasks
struct apps{
        int used;
        DCM *handle;
        char path[100];
        char cmdline[100];
        int thread;
};
APPS app[MAXAPPS];

typedef struct dlls DLLS;               //applications and tasks
struct dlls{
	char dname[20];			//used for identifying device drivers
        int used;
        DCM *dcmhandle;
};
DLLS dll[100];

typedef struct events EVENTS;               //applications and tasks
struct events{
        int used;
        int data;
        void (*CallBack)(int data);
};
EVENTS event[100];

typedef struct ikonsockets IKONSOCKETS;
struct ikonsockets{
        int used;
        int id;
        int socket;
        struct sockaddr_in addr;
};
IKONSOCKETS ikonsocket[100];

void DoEvents();
void *ex_proc_handler(int proc);
void KillApp(int pid);
void shutdownkernel(void);
void doshutdown(void);
void RunApp(char *appfilename);
void RefreshDesktop(void);
void mousehandler(void);
void mainloop(void);
int scrw;
int scrh;

//interface to gui.dll
void *Get_DLL_Function(int handle,int function);
void (*RestartEvents)(void);
void (*SystemMessage)(char *message);

void RunApp2(char *appfilename)
{
        int dummy;              //dummy is actually the PID for the app
        int pidreturned;
        int buttonid;           //button id for taskbar button
        dummy=0;
        char *temp;
        char *temp2;
        char cmdline[100];
        FILE *tempfile;
        //Now we have to see if the file even exists.
        temp2=strrchr(appfilename,' ');
        if(temp2!=NULL)
        {
                strcpy(cmdline,temp2+1);
                temp2[0]=0x00;
        }
        else
        {
                strcpy(cmdline,"");
        };
        tempfile=fopen(appfilename,"rt");
        if(!tempfile)
        {
                return;       //it doesnt exist so return
        };
        fclose(tempfile);       //it does exist so close it so DCM can load it

        do{
                dummy=dummy+1;
                if (dummy>MAXAPPS)
                {
                        dummy==0;
                        break;
                };
                if (app[dummy].used==0)
                {
                        app[dummy].used=1;
                        //now we get the apps path without appname
                        temp=strrchr(appfilename,'\\');
                        if(temp==NULL)
	                        temp=strrchr(appfilename,'/');
                        if(temp==NULL)
                                temp=appfilename+strlen(appfilename);
                        strncpy(app[dummy].path,appfilename,temp-appfilename);
                        app[dummy].path[temp-appfilename]=0x00;
                        strcpy(app[dummy].cmdline,cmdline);
                        app_dcm=Load_DCM(appfilename, &ex_proc_handler, NULL);
                        app[dummy].handle=app_dcm;
                        //asign the app a pid which dummy holds
                        app_dcm->dcm_var(app_dcm,dummy);
                        app_dcm->dcm_proc(app_dcm,dummy);
                        break;
                };
        }while(dummy<MAXAPPS);
};

void RunApp(char *f2name)
{
	char *temp;
	char *temp2;
	char buff[100];
	char path[100];
	char fname[100];
	char tdrive[4];
	char mydrive[4];
	FILE *f1;
	int cnt;
	char *fbuff;
	cnt=0;
	memset(buff,0,sizeof(buff));
	strcpy(buff,f2name);
	strupr(buff);
	if(strstr(buff,".APP")==0)
	{
		memset(buff,0,sizeof(buff));
		_fixpath("system",buff);
		strncpy(mydrive,buff,2);
		_fixpath(f2name,fname);
		strncpy(tdrive,fname,2);
		do{
			if(fname[cnt]=='/')
				fname[cnt]='\\';
			cnt++;
			if(cnt>strlen(fname))
				break;
		}while(1);

		//they want to run a dos program
		memset(buff,0,sizeof(buff));
		memset(path,0,sizeof(path));
		temp=strrchr(fname,'\\');
		if(temp==NULL)
			temp=fname;
		strncpy(path,fname+2,temp-fname-1);
		strcpy(buff,temp+1);
		f1=fopen("system\\exec.bat","wt");
		//fprintf(f1,"drivers\\net\\ne2000 -u\n");
		fprintf(f1,"%s\n",tdrive);
		fprintf(f1,"cd %s\ncall %s\n%s\ncd \\ikon\nikon.bat",path,buff,mydrive);
		fclose(f1);
		allegro_exit();
		exit(0);
	}
	else
	{
		RunApp2(f2name);
		return;
	}
}

void errorhandler(int sig)
{
        int cnt;
        SystemMessage("WARNING: Ikon encountered an error.\r\n\r\n"
        "\r\n\r\nAll program GenEvents have been\r\ncancelled!"
        "\r\n\r\nIf you continue to encounter errors\r\nreboot the system.");
        cnt=0;
        do{
                event[cnt].used=0;
                cnt++;
                if(cnt==100)
                        break;
        }while(1);
        RestartEvents();
	longjmp(env,1);
        return;
};

void mainloop()
{
        do{
                DoEvents();
                mousehandler();
        }while(1);
};

int main(void)
{
   int id;
        int mx,my,mb;
	int colordepth;
	int scrw;
	int scrh;
   int temp;
   FILE *systemini;     //this is the handle for our system.ini file
   char *fbuff;         //temporary file buffer
   char tmpstr[60];     //temp string for use in system.ini strings
   char readline[80];  //the filename of any apps or drivers to run on startup
   size_t maxchars;     //index into stings in system.ini
        systemini=fopen("system\\system.ini","rt");
        fbuff=fgets(readline,60,systemini);
        fclose(systemini);
        readline[strlen(readline)-1]=0;
        strcpy(tmpstr,readline+4);
        fbuff=strtok(tmpstr,",");
        scrw=atoi(fbuff);
        fbuff=strtok(0,",");
        scrh=atoi(fbuff);
        fbuff=strtok(0,",");
        colordepth=atoi(fbuff);
	//setup the clipboard
	clipboard=(char *)malloc(100000);
   /*   INIT THE LIBRARIES
        If anything goes wrong or doesn't init properly we can either quit
        now to DOS or just set a flag somewhere.        */
        allegro_init();
        install_timer();
        sock_init();
	hires_timer(0);
        set_color_depth(colordepth);
        set_gfx_mode(GFX_SAFE,scrw,scrh,0,0);
        install_keyboard();
        //install_timer();
        install_mouse();
        text_mode(-1);
        set_mouse_speed(0,0);
        set_keyboard_rate(200,10);
        signal(SIGSEGV,errorhandler);
        install_sound(DIGI_AUTODETECT,MIDI_AUTODETECT,"./");
   jpgalleg_init();             // JPGALLEG LIBARY
        algif_init();           //gif library
   /* Now we can set up and display the desktop as everything above has
        been initialized properly.                              */

        poll_mouse();  
        show_mouse(0);
        oldmousex=mouse_x;
        oldmousey=mouse_y;
        mousehidden=1;
        mousescreen=create_bitmap(20,20);
        mousecursor=load_bitmap("icons/mouse.bmp",0);
        Load_DLL("system\\gui.dll");
//setup any functions needed for gui.dll
        SystemMessage=Get_DLL_Function(1,38);
        RestartEvents=Get_DLL_Function(1,41);
	mousehidden=0;
        //blit(screen,mousescreen,mouse_x,mouse_y,0,0,20,20);
	setjmp(env);
        mainloop();
   return 0;
}
END_OF_MAIN();

void shutdownkernel(void)
{
        //doshutdown();
        exit(0);
};

void doshutdown(void)
{
        //user confirmed that they want to shut down ikon
        //shut down the kernel and exit to dos!
        int dummy;
        do{
                dummy=dummy+1;
                if (dummy>MAXAPPS)
                {
                        break;
                };
                if (app[dummy].used==1)
                {
                        app[dummy].used=0;
                        app_dcm=app[dummy].handle;
                        Free_DCM(app_dcm);
                };
        }while(dummy<MAXAPPS);
        shutdownkernel();
};

//quit a user application and free its memory
//surprised it doesnt crash since it returns to the caller application???
void ExitApp(int pid)
{
        DCM *crap;
        crap=app[pid].handle;
        app[pid].used=0;
        Free_DCM(crap);
};

BITMAP *getmousebuffer()
{
	return mousescreen;
}


//**************[ APPLICATION DLL AND DRIVER INTERFACES ]***********
int Load_DLL(char *filename)
{
        //returns a handle to the DLL or NULL on error
        int dummy;
        dummy=0;
        int temp;
        FILE *tempfile;
        //Now we have to see if the file even exists.
        tempfile=fopen(filename,"rt");
        if(!tempfile)
        {
                return 0;       //it doesnt exist so return
        };
        fclose(tempfile);       //it does exist so close it so DCM can load it
        dummy=0;
        do{
                dummy=dummy+1;
                if (dummy>100)
                {
                        dummy==0;
                        break;
                };
                if (dll[dummy].used==0)
                {
                        app_dcm=Load_DCM(filename, &ex_proc_handler, NULL);
                        dll[dummy].dcmhandle=app_dcm;
                        dll[dummy].used=1;
                        app_dcm->dcm_proc(app_dcm,dummy);
                        break;
                };
        }while(dummy<101);
        return dummy;
};

void DoEvents()
{
        int temp;
        temp=50;
        do{
                temp--;
                if(event[temp].used==1)
                {
                        event[temp].CallBack(event[temp].data);
                        event[temp].data=0;
                        event[temp].used=0;
                }
		if(temp==0)
			break;
        }while(1);
};

void GenEvent(void (*CallBack)(int data),int data)
{
        int temp;
        temp=0;
        do{
                temp=temp+1;
                if(event[temp].used==0)
                {
                        event[temp].used=1;
                        event[temp].data=data;
                        event[temp].CallBack=CallBack;
                        break;
                }
		if(temp==49)
			break;
        }while(1);
};

void mousehandler()
{

        poll_mouse();
        if(oldmousex==mouse_x && oldmousey==mouse_y)
                return;
        if(mousehidden==0)
        {
                blit(mousescreen,screen,0,0,oldmousex,oldmousey,20,20);
                blit(screen,mousescreen,mouse_x,mouse_y,0,0,20,20);
                masked_blit(mousecursor,screen,0,0,mouse_x,mouse_y,20,20);
        }
        oldmousex=mouse_x;
        oldmousey=mouse_y;
};

void myscare_mouse()
{
        mousehidden=1;
        blit(mousescreen,screen,0,0,oldmousex,oldmousey,20,20);
};

void myunscare_mouse()
{
        //mousehidden=2;
        poll_mouse();
	mousehidden=0;
        blit(screen,mousescreen,mouse_x,mouse_y,0,0,20,20);
        masked_blit(mousecursor,screen,0,0,mouse_x,mouse_y,20,20);
        oldmousex=mouse_x;
        oldmousey=mouse_y;
};

char *GetPath(int pid)
{
        return app[pid].path;
};

char *GetCommand(int pid)
{
        return app[pid].cmdline;
};

int Get_Device_Handle(char *dname)
{
	int d;
	int cnt;
	cnt=0;
	do{
		if(strcmp(dname,dll[cnt].dname)==0)
		{
			return cnt;
		}
		cnt++;
		if(cnt>100)
			break;
	}while(1);
	return 0;
};

void Register_Device(int id,char *dname)
{
	if(dll[id].used==1)
	{
		memset(dll[id].dname,0,20);
		strcpy(dll[id].dname,dname);
	}

};

void *Get_DLL_Function(int handle,int function)
{
        app_dcm=dll[handle].dcmhandle;
        return(app_dcm->dcm_var(app_dcm,function));
};

void Unload_DLL(int handle)
{
        //unloads a dynamic link library
        app_dcm=dll[handle].dcmhandle;
        dll[handle].used=0;
        Free_DCM(app_dcm);
};

FONT *SystemFont(){
        return GetCguiFont();
};

//**************[  ALLEGRO EXPORT FUNCTIONS ]****************
BITMAP *GetScreen(void)
{
        return screen;
};

void GetScreenRes(int *w,int *h)
{
        *w=SCREEN_W;
        *h=SCREEN_H;
	//*w=scrw;
	//*h=scrh;
};

void GetMouse(int *mousex,int *mousey,int *mouseb)
{
        mousehandler();
        *mousex=mouse_x;
        *mousey=mouse_y;
        *mouseb=mouse_b;
};

void socket_send_byte(int id,char c)
{
	char buff[3];
	memset(buff,0,3);
	buff[0]=c;
        write_s(ikonsocket[id].socket,buff,1);
};

void socket_send_bytes(int id,char *buff,int bytes)
{
        write_s(ikonsocket[id].socket,buff,bytes);
};

int socket_recieve(int id,char *buff,int num)
{
        char buf[100];
        int temp;
        //temp=read_s(ikonsocket[id].socket,buff,num);
        temp=recv(ikonsocket[id].socket,buff,num,0);
        return temp;
};

int socket_listen(int id)
{
        int i;
        i=listen(ikonsocket[id].socket,5);
        return i;
};

int socket_accept(id)
{
        //returns a new socket
        int i,sin_size;
        int temp=1;
        for(;;)
        {
                if(ikonsocket[temp].used==0)
                {
                        ikonsocket[temp].used=1;
                        ikonsocket[temp].id=temp;
                        break;
                };
                temp=temp+1;
                if(temp>99)
                {
                        temp=100;
                        break;
                };
        };
        if(temp!=100)
        {
                memset(&ikonsocket[temp].addr,0,sizeof(ikonsocket[temp].addr));
                sin_size=sizeof(struct sockaddr_in);
                i=accept(ikonsocket[id].socket,(struct sockaddr *)&ikonsocket[temp].addr,&sin_size);
                ikonsocket[temp].socket=i;
                return temp;
        };
};

int socket_select(int id,int delayt)
{
        int i;
        FD_ZERO(&readhandles);
        FD_SET(ikonsocket[id].socket,&readhandles);
        timeout.tv_sec=0;
        timeout.tv_usec=delayt;
        i=select(ikonsocket[id].socket+1,&readhandles,0,0,&timeout);
        return i;
};

void socket_close(int id)
{
        ikonsocket[id].used=0;
        close_s(ikonsocket[id].socket);
};

int socket_bind(int id,char *ipaddress,int port)
{
        int i;
        ikonsocket[id].addr.sin_family=AF_INET;
        ikonsocket[id].addr.sin_port=htons(port);
        ikonsocket[id].addr.sin_addr.s_addr=inet_addr(ipaddress);
        ikonsocket[id].addr.sin_port=htons(port);
        i=bind(ikonsocket[id].socket,(struct sockaddr *)&ikonsocket[id].addr,sizeof(struct sockaddr));
        return i;
};

/*int socket_connect(int id,char *ipaddress,int port)
{
        int i;
        long r;
        memset(&ikonsocket[id].addr,0,sizeof(ikonsocket[id].addr));
        ikonsocket[id].addr.sin_family=AF_INET;
        ikonsocket[id].addr.sin_port=htons(port);
        //he=gethostbyname(ipaddress);
        r=resolve(ipaddress);
        ikonsocket[id].addr.sin_addr.s_addr=htonl(r);
        //memcpy(&ikonsocket[id].addr.sin_addr.s_addr,he->h_addr,he->h_length);
        i=connect(ikonsocket[id].socket,(struct sockaddr*)&ikonsocket[id].addr,sizeof(ikonsocket[id].addr));
        return i;
};
*/

int socket_connect(int id,char *ipaddress,int port)
{
        int i;
	unsigned int r;
	r=resolve(ipaddress);
	if (r==0)
		return (-1);
        ikonsocket[id].addr.sin_family=AF_INET;
        ikonsocket[id].addr.sin_port=htons(port);
        ikonsocket[id].addr.sin_addr.s_addr=htonl(r);
        i=connect(ikonsocket[id].socket,(struct sockaddr*)&ikonsocket[id].addr,sizeof(ikonsocket[id].addr));
        return i;
};

int socket_open(void)
{
        int temp;
        temp=1;
        for(;;)
        {
                if(ikonsocket[temp].used!=1)
                {
                        ikonsocket[temp].used=1;
                        ikonsocket[temp].id=temp;
                        ikonsocket[temp].socket=socket(AF_INET,SOCK_STREAM,0);
                        return temp;
                };
                temp=temp+1;
                if(temp>99)
                {
                        return 0;
                };
        };
};

void copyfile(char *src,char *dst)
{
        FILE *sf;
        FILE *df;
        int buff;
        sf=fopen(src,"rb");
        df=fopen(dst,"wb");
        do{
                buff=fgetc(sf);
                if(buff==EOF)
                        break;
                fputc(buff,df);
        }while(1);
        fclose(sf);
        fclose(df);
};

void PutClipboard(char *data,int len)
{
	memset(clipboard,0,100000);
	strncpy(clipboard,data,len);
}

char * GetClipboard()
{
	return clipboard;
}

float GetIkonVersion()
{
	return VERSION;
}


//**************{  APPLICATION FUNCTION EXPORTS ]**************

//lets give the apps some functions to call
void *ex_proc_handler(int proc)
{
        if(proc==0)
        {
                return(&GenEvent);
        }
        if (proc==1)
        {
                return(&ExitApp);
        }
        if (proc==2)
        {
                return(&SystemFont);
        }
        if (proc==3)
        {
                return(&GetScreenRes);
        }
        if (proc==4)
        {
                return(&doshutdown);
        }
        if(proc==5){return(&readkey);}
        if(proc==6){return(&keypressed);}
        if(proc==7){return(&scancode_to_ascii);}
        if(proc==8){return(&text_length);}
        if(proc==9){return(&text_height);}
        if(proc==10){return(&masked_stretch_blit);}
        if(proc==11){return(&DoEvents);}
        if(proc==12){return(&findfirst);}
        if(proc==13){return(&findnext);}
        if(proc==14){return(&socket_send_byte);}
        if(proc==15){return(&getdisk);}
        if(proc==16){return(&rename);}
        if(proc==17){return(&mkdir);}
        if(proc==18){return(&rmdir);}
        if(proc==19){return(&_fixpath);}
        if(proc==20){return(&system);}
        if(proc==21){return(&load_gif);}
        if(proc==22){return(&save_gif);}
        if(proc==23){return(&algif_load_animation);}
        if(proc==24){return(&set_volume);}
        if(proc==25){return(&load_sample);}
        if(proc==26){return(&destroy_sample);}
        if(proc==27){return(&play_sample);}
        if(proc==28){return(&adjust_sample);}
        if(proc==29){return(&copyfile);}
	if(proc==30){return(&getdate);}
	if(proc==31){return(&gettime);}
	if(proc==32){return(&printf);}
	if(proc==33){return(&int86);}
	if(proc==34){return(&load_ttf_font);}
	if(proc==35){return(&destroy_font);}
	if(proc==36){return(&_dos_setdrive);}
	if(proc==37){return(&_dos_getdrive);}
	if(proc==38){return(&getmousebuffer);}
	if(proc==123){return(&delay);}
        if (proc==124)
        {
                return(&fputs);
        }
        else if (proc==125)
        {
                return(&fprintf);
        }
        else if (proc==126)
        {
                return(&fopen);
        }
        else if (proc==127)
        {
                return(&fclose);
        }
        else if (proc==128)
        {
                return(&feof);
        }
        else if (proc==129)
        {
                return(&ferror);
        }
        else if (proc==130)
        {
                return(&fflush);
        }
        else if (proc==131)
        {
                return(&fgetc);
        }
        else if (proc==132)
        {
                return(&fgetpos);
        }
        else if (proc==133)
        {
                return(&fgets);
        }
        else if (proc==134)
        {
                return(&fputc);
        }
        else if (proc==135)
        {
                return(&fseek);
        }
        else if (proc==136)
        {
                return(&fsetpos);
        }
        else if (proc==138){return(&RunApp);}
        //************ALLEGRO FUNCTIONS ******************
        else if (proc==139){return(&GetScreen);}
        else if (proc==140){return(&line);}
        else if (proc==141){return(&GetMouse);}
        else if (proc==142){return(&rectfill);}
        else if (proc==143){return(&rect);}
        else if (proc==144){return(&circle);}
        else if (proc==145){return(&circlefill);}
        else if (proc==146){return(&makecol);}
        else if (proc==147){return(&getpixel);}
        else if (proc==148){return(&floodfill);}
        else if (proc==149){return(&load_bitmap);}
        else if (proc==150){return(&save_bitmap);}
        else if (proc==151){return(&blit);}
        else if (proc==152){return(&destroy_bitmap);}
        else if (proc==153){return(&putpixel);}
        else if (proc==154){return(&create_bitmap);}
        else if (proc==156){return(&textout);}
        else if (proc==157){return(&textout_centre);}
        else if (proc==158){return(&remove);}
        else if (proc==159){return(&draw_sprite);}
        else if (proc==160){return(&masked_blit);}
        else if (proc==161){return(&set_clip);}
        else if (proc==164){return(&textprintf);}
        else if (proc==165){return(&textprintf_centre);}
        else if (proc==166){return(&load_jpg);}
        else if (proc==167){return(&save_jpg);}
        //*********DLL FUNCTIONS*****************
        else if (proc==169){return(&Load_DLL);}
        else if (proc==170){return(&Unload_DLL);}
        else if (proc==171){return(&Get_DLL_Function);}
        //**********KERNEL STUFF AGAIN*************
        else if (proc==173){return(&sprintf);}
        else if (proc==174){return(&spawnvpe);}
        else if (proc==175){return(&GetPath);}
        else if (proc==176){return(&myscare_mouse);}
        else if (proc==177){return(&myunscare_mouse);}
          else if (proc==179){return(&create_sub_bitmap);}
          else if (proc==180){return(&triangle);}
          else if (proc==181){return(&stretch_sprite);}
          else if (proc==182){return(&stretch_blit);}
          else if (proc==183){return(&rotate_sprite);}
          else if (proc==184){return(&malloc);}
          else if (proc==185){return(&free);}
          else if (proc==186){return(&socket_send_bytes);}
          else if (proc==187){return(&socket_recieve);}
          else if (proc==188){return(&socket_close);}
          else if (proc==189){return(&socket_connect);}
          else if (proc==190){return(&socket_open);}
          else if (proc==191){return(&socket_bind);}
          else if (proc==192){return(&socket_listen);}
          else if (proc==193){return(&socket_select);}
          else if (proc==194){return(&socket_accept);}
          else if (proc==195){return(&GetCommand);}
	else if (proc==196){return(&Get_Device_Handle);}
	else if (proc==197){return(&Register_Device);}
	else if (proc==198){return(&PutClipboard);}
	else if (proc==199){return(&GetClipboard);}
	else if (proc==200){return(&GetIkonVersion);}
	else if (proc==201){return(&fread);}
	else if (proc==202){return(&fwrite);}
	else if (proc==203){return(&stat);}
	else if (proc==204){return(&mktemp);}
	else if (proc==205){return(&install_int);}
	else if (proc==206){return(&remove_int);}
	else if (proc==207){return(&_go32_dpmi_lock_data);}
	else if (proc==208){return(&_go32_dpmi_lock_code);}
	else if (proc==209){return(&tan);}
	else if (proc==210){return(&cos);}
	else if (proc==211){return(&sin);}
	else if (proc==212){return(&get_mouse_mickeys);}
	else if (proc==213){return(&fscanf);}
	else if (proc==214){return(&clear_to_color);}
	else if (proc==215){return(&sqrt);}
	else if (proc==216){return(&floor);}
	else if (proc==217){return(&rewind);}
                return(0);
};


