/* Sample Ikon Application
*
*	COMPILE: makeapp test
*		-OR-
*	gcc -c test.c -otest.o
*	dxegen test.app _mod_init test.o
*
*/
#include <stdlib.h>
#include <ikon.h>          /* ikon.h should ALWAYS be first */
#include <gui.h>	/* needed for gui routines */

static void appmain();
int ourwinid;           //id for our window
char display[30];	//display;
char userentry[30];	//user entry buffer
int opcnt;
BITMAP *winbmp;
int WHITE;
int whichoperation;
volatile double lastval;
volatile double total;
#define TOP 24
#define LEFT 24

#define EQUALS 10
#define TIMES 11
#define DIVIDE 12
#define CLEAR 13
#define MINUS 14
#define PLUS 15
#define PIB 16
#define DECIMAL 17
int BUTCOL;

//***** This function only needs modification for DLL's and drivers****

void *var_router(DCM *dcm, int function)
{
  return(0);
}

//*******************************************************************

void ExitHandler(int data)
{
        if(data==0)
        {       
                CloseWin(ourwinid);	//close our window
                ExitApp(pid);		//exit the application
					//NOTE: pid is a globally define integer
					//that is initialized automatically
					//when your application is run.
					//You DO NOT have to declare it!
        }

}

void ftoa(float i,char *str,int base)
{
	sprintf(str,"%f",i);
}

void updatedisplay()
{
	rectfill(winbmp,5,24,205,45,WHITE);
	rect(winbmp,5,24,205,45,0);
	textout(winbmp,SystemFont(),display,205-(strlen(display)*9),28,0);
}

void domath(int data)
{
	char buff[50];
	double temp;
	int cnt;
	memset(buff,0,50);
	if(data>(-1) && data<10)
	{
		itoa(data,buff,10);
		strcat(userentry,buff);
		memset(display,0,sizeof(display));
		strcpy(display,userentry);
		if(strstr(userentry,".")==0)
		{
			strcat(display,".0");
		}
	}
	if(data==DECIMAL)
	{
		if(strstr(userentry,".")!=0)
			return;
		if(strlen(userentry)==0)
			strcpy(userentry,"0");
		strcat(userentry,".");
		memset(display,0,sizeof(display));
		strcpy(display,userentry);
		strcat(display,"0");
	}
	if(data==PLUS || data==MINUS || data==DIVIDE || data==TIMES)
	{
		temp=0;
		if(whichoperation!=data && whichoperation!=0)
		{
			if(whichoperation==PLUS)
			{
				lastval=lastval+atof(display);
				//memset(display,0,sizeof(display));
				//ftoa(lastval,display,10);
			}
			if(whichoperation==MINUS)
			{
				lastval=lastval-atof(display);
				//memset(display,0,sizeof(display));
				//ftoa(lastval,display,10);
			}
			if(whichoperation==TIMES)
			{
				lastval=lastval*atof(display);
				//memset(display,0,sizeof(display));
				//ftoa(lastval,display,10);
			}
			if(whichoperation==DIVIDE)
			{
				lastval=lastval/atof(display);
				//memset(display,0,sizeof(display));
				//ftoa(lastval,display,10);
			}
			memset(display,0,sizeof(display));
			if(data==PLUS)
				temp=0;
			if(data==MINUS)
				temp=0;
			if(data==DIVIDE)
				temp=1;
			if(data==TIMES)
				temp=1;
			ftoa(temp,display,10);
		}
		if(whichoperation!=0)
		{
			if(data==PLUS)
			{
				lastval=lastval+atof(display);
				memset(display,0,sizeof(display));
				ftoa(lastval,display,10);
			}
			if(data==MINUS)
			{
				lastval=lastval-atof(display);
				memset(display,0,sizeof(display));
				ftoa(lastval,display,10);
			}
			if(data==TIMES)
			{
				lastval=lastval*atof(display);
				memset(display,0,sizeof(display));
				ftoa(lastval,display,10);
			}
			if(data==DIVIDE)
			{
				lastval=lastval/atof(display);
				memset(display,0,sizeof(display));
				ftoa(lastval,display,10);
			}
		}
		if(whichoperation==0)
		{
			lastval=atof(display);
		}
		memset(userentry,0,sizeof(userentry));
		total=0.0;
		whichoperation=data;
	}
	if(data==PIB)
	{
		memset(display,0,sizeof(display));
		strcpy(display,"3.14159");
	}
	if(data==EQUALS)
	{
		if(whichoperation==PLUS)
		{
			total=lastval+atof(display);
		}
		if(whichoperation==MINUS)
		{
			total=lastval-atof(display);
		}
		if(whichoperation==TIMES)
		{
			total=lastval*atof(display);
		}
		if(whichoperation==DIVIDE)
		{
			total=lastval/atof(display);
		}
		if(whichoperation!=0)
		{
			whichoperation=0;
			ftoa(total,buff,10);
			memset(display,0,sizeof(display));
			memset(userentry,0,sizeof(userentry));
			strcpy(display,buff);
			lastval=total;
		}
	}
	if(data==CLEAR)
	{
		memset(userentry,0,sizeof(userentry));
		memset(display,0,sizeof(display));
		total=0.0;
		lastval=0.0;
		strcpy(display,"0.");
		whichoperation=0;
	}
	cnt=strlen(display)-1;
	do{
		//get rid of stupid zeroes
		if(display[cnt]=='0')
		{
			display[cnt]=0;
		}
		else
		{
			break;
		}
		cnt--;
		if(cnt==0)
			break;
	}while(1);
	
	updatedisplay();
	RefreshWin(ourwinid);
}

static void appmain()	//called appmain, not main!!!
{
  //*********[ Your main program routine ]****************
	int top;
	int left;
	int right;
	int bottom;
	FONT *f;

        InitGUI();	//initializes pointers to gui procedures and functions
	BUTCOL=makecol(190,190,190);
	WHITE=makecol(0xff,0xff,0xff);
	f=load_ttf_font("fonts\\mono-b.ttf",12,1);
	//now we'll make a blank window with 'Hello World' as the caption	
	//ExitHandler is a pointer to the function above, it is called
	//when a user clicks the 'X' in the top right of the window.
        ourwinid=MakeWindow(10,30,210,200,"Calculator",ExitHandler,0);
	winbmp=GetWinBMP(ourwinid);
	left=LEFT;
	top=TOP+30;
	bottom=30;
	right=30;

	MakeColorButton(ourwinid,left,top,right,bottom,WHITE,BUTCOL,"7",f,domath,7);
	left=left+32;
	MakeColorButton(ourwinid,left,top,right,bottom,WHITE,BUTCOL,"8",f,domath,8);
	left=left+32;
	MakeColorButton(ourwinid,left,top,right,bottom,WHITE,BUTCOL,"9",f,domath,9);
	left=left+32;
	MakeColorButton(ourwinid,left,top,right,bottom,WHITE,BUTCOL,"+",f,domath,PLUS);
	left=left+32;
	MakeColorButton(ourwinid,left,top,right,bottom,WHITE,BUTCOL,"C",f,domath,CLEAR);
	left=LEFT;
	top=top+32;
	MakeColorButton(ourwinid,left,top,right,bottom,WHITE,BUTCOL,"4",f,domath,4);
	left=left+32;
	MakeColorButton(ourwinid,left,top,right,bottom,WHITE,BUTCOL,"5",f,domath,5);
	left+=32;
	MakeColorButton(ourwinid,left,top,right,bottom,WHITE,BUTCOL,"6",f,domath,6);
	left+=32;
	MakeColorButton(ourwinid,left,top,right,bottom,WHITE,BUTCOL,"-",f,domath,MINUS);
	left+=32;
	MakeColorButton(ourwinid,left,top,right,bottom,WHITE,BUTCOL,"Pi",f,domath,PIB);
	left=LEFT;
	top=top+32;
	MakeColorButton(ourwinid,left,top,right,bottom,WHITE,BUTCOL,"1",f,domath,1);
	left+=32;
	MakeColorButton(ourwinid,left,top,right,bottom,WHITE,BUTCOL,"2",f,domath,2);
	left+=32;
	MakeColorButton(ourwinid,left,top,right,bottom,WHITE,BUTCOL,"3",f,domath,3);
	left+=32;
	MakeColorButton(ourwinid,left,top,right,bottom,WHITE,BUTCOL,"/",f,domath,DIVIDE);
	left+=32;
	MakeColorButton(ourwinid,left,top,right,bottom+32,WHITE,BUTCOL,"=",f,domath,EQUALS);
	left=LEFT;
	top=top+32;
	MakeColorButton(ourwinid,left,top,right,bottom,WHITE,BUTCOL,"0",f,domath,0);
	left+=32;
	MakeColorButton(ourwinid,left,top,right,bottom,WHITE,BUTCOL,".",f,domath,DECIMAL);
	left+=32;
	MakeColorButton(ourwinid,left,top,right,bottom,WHITE,BUTCOL," ",f,domath,CLEAR);
	left+=32;
	MakeColorButton(ourwinid,left,top,right,bottom,WHITE,BUTCOL,"*",f,domath,TIMES);
	memset(userentry,0,sizeof(userentry));
	memset(display,0,sizeof(display));
	strcpy(display,"0.");
	destroy_font(f);
	total=0.0;
	lastval=0.0;
	opcnt=0;
	updatedisplay();
        RefreshWin(ourwinid);
}



